%%
%
%
%
ccc
load('attendee_data');
load('l1');
load('l2');
load('l3');
load('tsne_out');
load('labels.mat');

%% LAYER 1 LEARNING CURVE
fig_l1c = figure();
plot(l1.learning_curve);
title('Deep Belief Net Layer 1 Learning Curve');
set(fig_l1c,'PaperPositionMode','auto')
print (fig_l1c , '-dpng', 'fig_l1c.png') ;

%% LAYER 2 LEARNING CURVE 
fig_l2c = figure();
plot(l2.learning_curve);
title('Deep Belief Net Layer 2 Learning Curve');
set(fig_l2c,'PaperPositionMode','auto')
print (fig_l2c , '-dpng', 'fig_l2c.png') ;

%% LAYER 3 LEARNING CURVE 
fig_l3c = figure();
plot(l3.learning_curve);
title('Deep Belief Net Layer 3 Learning Curve');
set(fig_l3c,'PaperPositionMode','auto')
print (fig_l3c , '-dpng', 'fig_l3c.png') ;

%% PLOT FEATURES
features = [d.interests d.motivs d.jobs_onehot];
features = features(1:d.nr_valid, :);

mx = 0.01;
my = 0.1;
fig_feat = figure();
subaxes(fig_feat, 1, 5, 1, mx, my);
imagesc(features); axis off; title('Raw Feature');
subaxes(fig_feat, 1, 5, 2, mx, my);
imagesc(l1.out); axis off; title('Layer 1 Output');
subaxes(fig_feat, 1, 5, 3, mx, my);
imagesc(l2.out); axis off; title('Layer 2 Output');
subaxes(fig_feat, 1, 5, 4, mx, my);
imagesc(l3.out); axis off; title('Layer 3 Output');
subaxes(fig_feat, 1, 5, 5, mx, my);
imagesc(tsne_out); axis off; title('t-SNE Output');
set(fig_feat,'PaperPositionMode','auto')
print (fig_feat , '-dpng', 'fig_feat.png') ;


%% PLOT CLUSTERING RESULTS
fig_cluster = figure(); clf; hold on;
colors = jet(nr_label);
for i = 1:length(tsne_out)
    for j = i:length(tsne_out)
        ti = tsne_out(i, :);
        tj = tsne_out(j, :);
        dij = norm(ti - tj);
        if dij < 3
            plot([ti(1) tj(1)], [ti(2) tj(2)], 'k-', 'LineWidth', 2);
        end
    end
end
for i = 1:nr_label
    idx = find(labels == i);
    plot(tsne_out(idx, 1), tsne_out(idx, 2), 'o', 'Color', 'k' ...
        , 'LineWidth', 2, 'MarkerSize', 12, 'MarkerFaceColor', colors(i, :));
end
grid on;
axis equal; axis off;
title(sprintf('Clustering Result (%d Groups)', nr_label));
set(fig_cluster,'PaperPositionMode','auto')
print (fig_cluster , '-dpng', 'fig_cluster.png') ;
% SAVE 
save('labels.mat', 'labels', 'nr_label');

%% BACKPROPAGATE TO SEE HOW THE FEATURES ARE CLUSTERED 
%  1-17: INTEREST (17)
% 18:24: MOTIVS (7)
% 25:33: JOBS (9)




