function fig = plot_interest_normalized(d)
colors = jet(length(d.interest_list));
nr_matches = zeros(length(d.interest_list), 1);
for i = 1:length(d.interest_list)
    nr_matches(i) = sum(d.interests_normalized(:, i));
end
[~, is] = sort(nr_matches);
fig = figure();
hold on;
strs = cell(length(d.interest_list), 1);
hs = zeros(length(d.interest_list), 1);
for ii = 1:length(d.interest_list)
    i = is(ii);
    hs(ii) = bar(ii, nr_matches(i), 'facecolor', colors(ii, :));
    strs{ii} = d.interest_list2{i};
end
legend(hs, strs, 'Location', 'NorthWest');
title(' о (Normalized)');
