function [visHid, visBiases, hidBiases, learning_curve] = ...
    train_rbm( trainData, maxepoch, numHid ...
    , CD, discretize, numCases, lr)

trainData = trainData';

learning_curve = zeros(maxepoch, 1);    
epsilonW  = lr;   % Learning rate for weights
epsilonVb = lr;   % Learning rate for biases of visible units
epsilonHb = lr;   % Learning rate for biases of hidden units

weightCost       = 0.001;
initialMomentum  = 0.5;
finalMomentum    = 0.5;

[numDims, numData] = size(trainData);
% numDims:     item Dimension
% numData:      

numBatches = numData/numCases;
trainBatchData = zeros(numCases, numDims, numBatches);
for bi = 1:numBatches
    for ci = 1:numCases
        trainBatchData(ci, :, bi) = trainData(:, bi + (ci-1)*numBatches);
    end
end

% Initializing symmetric weights and biases.
visHid     = 0.001*randn(numDims, numHid);
hidBiases  = zeros(1,numHid);
visBiases  = zeros(1,numDims);
posHidProbs = zeros(numCases, numHid);   % positive Phase  Hidden Node 1  Ȯ
negHidProbs = zeros(numCases, numHid);   % negative Phase  Hidden Node 1  Ȯ
posProds    = zeros(numDims, numHid);   % positive Phase  E(vh)
negProds    = zeros(numDims, numHid);   % negative Phase  E(vh) - 1step CD Ѵ.
visHidInc   = zeros(numDims, numHid);   % vis Hid ϴ weight ȭ
hidBiasInc  = zeros(1,numHid);          % Hid layer  node  bias
visBiasInc  = zeros(1,numDims);         % Vis layer  node  bias

epoch = 1;
for epoch = epoch : maxepoch
    
    errsum = 0;
    for batch = 1 : numBatches     
        %  batch ؼ, ( batch 100 item ̷ְ,  item 784 data  ִ.)
        
        % ϳ batch ѹ óϱ ؼ bias repmat δ. numData batchȿ Item ̴.
        visBias = repmat(visBiases, numCases, 1);
        hidBias = repmat(hidBiases, numCases, 1);
        
       %% %%%%%%% START POSITIVE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%% positive phase   ִ data ̿ؼ  expectation Ѵ.
        %data = trainData(:, batch)';
        data = trainBatchData(:, :, batch);
        %  index batch ´. ( batch 100 Item Ѵ.)
        %  data numData,  100 digit   ִ.   0~1 ̴.
        
        if discretize == 1
            data = data > rand(size(data));
        else
            data = data;
        end
        %   0Ǵ 1 ٲ۴. RBM binary ó  ־ ̷ ƾ ִ´.
        
        posHidProbs = 1./ (1 + exp(-data*(2*visHid) - hidBias));
        % posHidProbs R[numData*numHid]   ִ.
        % i°   batch i° item ǹϰ, (numData Item ѹ óϴ ̴.)
        % j°  ش item j° hidden node 1  Ȯ ǹѴ.
        
        %batchPosHidProbs(:, :, batch) = posHidProbs; % Ⱦδ.
        % batchPosHidProbs R[numData*numHid*numBatches] ũ⸦ ´.
        %   loop  batch ѹ µ ̸   ϰ, batchPosHidProbs ⼱ Ⱦδ.
        
        posProds    = data' * posHidProbs;
        % posProds R[numDims, numHid] ũ⸦ ´.
        %  batch  data  E(vh),  i° vis j° hid  E(vis*hid)̴.
        
        posHidAct   = sum(posHidProbs);
        % posHidAct R[numHid] ũ⸦ ´.
        %  item ڿ numData   batch  E(h) Ÿ.
        % hidBias update  δ.
        
        posVisAct   = sum(data);
        % posHidAct R[numDims] ũ⸦ ´.
        %  item ڿ numData   batch  visible node 밪 Ÿ.
        % visBias update  δ.
        
       %% %%%%%%% END OF POSITIVE PHASE  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
       %% %%% START NEGATIVE PHASE  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        posHidProbs_temp = posHidProbs;
        for cdIter = 1:CD
            if discretize == 1
                poshidstates = posHidProbs_temp > rand(size(posHidProbs_temp));
            else
                poshidstates = posHidProbs_temp;
            end
            % posHidProbs տ   batch  item鿡 ؼ,  hidden node 1  Ȯ̴.
            % poshidstates RBM binary  ؼ ̸ 1Ǵ 0 ٲ۴.
            
            negData = 1./(1 + exp(-poshidstates*visHid' - visBias));
            % negData ռ positive phase  hid node (1 if Ȯ>rand)    ִ
            % visHid,  vis hid ϴ weight ؼ ᱹ neg phase vis 1̵ Ȯ ǹѴ.
            % ̴  batch  item ؼ visible node 1  Ȯ ǹѴ.
            
            if discretize == 1
                negData = negData > rand(size(negData));
            else
                negData = negData;
            end
            % RBM binary data(0Ǵ 1)ۿ   .  neg phase vis data ǹѴ.
            
            posHidProbs_temp = 1./(1 + exp(-negData*(2*visHid) - hidBias));
            % negHidProbs   batch  data ؼ  hidden node 1  Ȯ Ÿ.
        end
        
        negHidProbs = posHidProbs_temp;
        
        negProds  = negData'*negHidProbs;
        % negProds R[784*50] ũ⸦ ´.
        %  batch  data  E(vh),  i° vis j° hid  E(vis*hid)̴.
        
        negHidAct = sum(negHidProbs);
        % negHidAct R[numHid] ũ⸦ ´.
        %  item ڿ numData   batch  hidden node 밪 Ÿ.
        % hidBias update δ.
        
        negVisAct = sum(negData);
        % negVisAct R[numDims] ũ⸦ ´.
        %  item ڿ numData   batch  visible node 밪 Ÿ.
        % visBias update δ.
       %% %%%%%%% END OF NEGATIVE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        err= sum(sum( (data - negData).^2 ));
        errsum = err + errsum; %  errsum batch ʱȭ ȴ.   batch   ǹ
        
        % Momentum based Learning -> momentum 0 ϸ  ʴ´.
        if epoch > 5
            momentum = finalMomentum;
        else
            momentum = initialMomentum;
        end;
        %momentum = 0;
        
       %% %%%%%%% UPDATE WEIGHTS AND BIASES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % inc Ѵ. E[pos]-E[neg]
        visHidInc = momentum*visHidInc + ...
            epsilonW*( (posProds-negProds)/numCases - weightCost*visHid ) ;
        visBiasInc = momentum*visBiasInc + (epsilonVb/numCases)*(posVisAct - negVisAct);
        hidBiasInc = momentum*hidBiasInc + (epsilonHb/numCases)*(posHidAct - negHidAct);
        
        %  update κ
        visHid = visHid + visHidInc;
        visBiases = visBiases + visBiasInc;
        hidBiases = hidBiases + hidBiasInc;
       %% %%%%%%%%%%%%%% END OF UPDATES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % disp([num2str(epoch) '/' num2str(maxepoch) ' - ' num2str(batch) '/' num2str(numData) ' error: ' num2str(errsum)]);
        
    end
        
    disp([num2str(epoch) '/' num2str(maxepoch) ' error: ' num2str(errsum)]);
    learning_curve(epoch) = errsum;
end;

